// ============================================================================
//
// Copyright (c) 2006-2015, Talaxie Inc.
//
// This source code has been automatically generated by_Talaxie Open Studio for Data Integration
// / Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.


package test.nextcloud_apache_conf_main_0_1;

import routines.Numeric;
import routines.DataOperation;
import routines.TalendDataGenerator;
import routines.TalendStringUtil;
import routines.TalendString;
import routines.StringHandling;
import routines.Relational;
import routines.TalendDate;
import routines.Mathematical;
import routines.system.*;
import routines.system.api.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.math.BigDecimal;
import java.io.ByteArrayOutputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.ObjectOutputStream;
import java.io.ObjectInputStream;
import java.io.IOException;
import java.util.Comparator;
 





@SuppressWarnings("unused")

/**
 * Job: nextcloud_apache_conf_main Purpose: <br>
 * Description:  <br>
 * @author fx.prunayre@gmail.com
 * @version 8.8.8.20240722_1936-SNAPSHOT
 * @status 
 */
public class nextcloud_apache_conf_main implements TalendJob {

protected static void logIgnoredError(String message, Throwable cause) {
       System.err.println(message);
       if (cause != null) {
               cause.printStackTrace();
       }

}


	public final Object obj = new Object();

	// for transmiting parameters purpose
	private Object valueObject = null;

	public Object getValueObject() {
		return this.valueObject;
	}

	public void setValueObject(Object valueObject) {
		this.valueObject = valueObject;
	}
	
	private final static String defaultCharset = java.nio.charset.Charset.defaultCharset().name();

	
	private final static String utf8Charset = "UTF-8";
	

	//contains type for every context property
	public class PropertiesWithType extends java.util.Properties {
		private static final long serialVersionUID = 1L;
		private java.util.Map<String,String> propertyTypes = new java.util.HashMap<>();
		
		public PropertiesWithType(java.util.Properties properties){
			super(properties);
		}
		public PropertiesWithType(){
			super();
		}
		
		public void setContextType(String key, String type) {
			propertyTypes.put(key,type);
		}
	
		public String getContextType(String key) {
			return propertyTypes.get(key);
		}
	}	
	// create and load default properties
	private java.util.Properties defaultProps = new java.util.Properties();
		

	// create application properties with default
	public class ContextProperties extends PropertiesWithType {

		private static final long serialVersionUID = 1L;

		public ContextProperties(java.util.Properties properties){
			super(properties);
		}
		public ContextProperties(){
			super();
		}

		public void synchronizeContext(){
			
			if(ncApacheConfDir != null){
				
					this.setProperty("ncApacheConfDir", ncApacheConfDir.toString());
				
			}
			
			if(ncHost != null){
				
					this.setProperty("ncHost", ncHost.toString());
				
			}
			
			if(ncPassword != null){
				
					this.setProperty("ncPassword", ncPassword.toString());
				
			}
			
			if(ncRevProxy != null){
				
					this.setProperty("ncRevProxy", ncRevProxy.toString());
				
			}
			
			if(ncUsername != null){
				
					this.setProperty("ncUsername", ncUsername.toString());
				
			}
			
			if(pgDatabase != null){
				
					this.setProperty("pgDatabase", pgDatabase.toString());
				
			}
			
			if(pgHost != null){
				
					this.setProperty("pgHost", pgHost.toString());
				
			}
			
			if(pgPassword != null){
				
					this.setProperty("pgPassword", pgPassword.toString());
				
			}
			
			if(pgPort != null){
				
					this.setProperty("pgPort", pgPort.toString());
				
			}
			
			if(pgSchema != null){
				
					this.setProperty("pgSchema", pgSchema.toString());
				
			}
			
			if(pgUsername != null){
				
					this.setProperty("pgUsername", pgUsername.toString());
				
			}
			
			if(ncRemoveAllShares != null){
				
					this.setProperty("ncRemoveAllShares", ncRemoveAllShares.toString());
				
			}
			
		}
		
		//if the stored or passed value is "<TALEND_NULL>" string, it mean null
		public String getStringValue(String key) {
			String origin_value = this.getProperty(key);
			if(NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY.equals(origin_value)) {
				return null;
			}
			return origin_value;
		}

		public String ncApacheConfDir;
		public String getNcApacheConfDir(){
			return this.ncApacheConfDir;
		}
		
public String ncHost;
public String getNcHost(){
	return this.ncHost;
}
public java.lang.String ncPassword;
public java.lang.String getNcPassword(){
	return this.ncPassword;
}
public String ncRevProxy;
public String getNcRevProxy(){
	return this.ncRevProxy;
}
public String ncUsername;
public String getNcUsername(){
	return this.ncUsername;
}
public String pgDatabase;
public String getPgDatabase(){
	return this.pgDatabase;
}
public String pgHost;
public String getPgHost(){
	return this.pgHost;
}
public java.lang.String pgPassword;
public java.lang.String getPgPassword(){
	return this.pgPassword;
}
public String pgPort;
public String getPgPort(){
	return this.pgPort;
}
public String pgSchema;
public String getPgSchema(){
	return this.pgSchema;
}
public String pgUsername;
public String getPgUsername(){
	return this.pgUsername;
}
public Integer ncRemoveAllShares;
public Integer getNcRemoveAllShares(){
	return this.ncRemoveAllShares;
}
	}
			
	protected ContextProperties context = new ContextProperties(); // will be instanciated by MS.
	public ContextProperties getContext() {
		return this.context;
	}
	private final String jobVersion = "0.1";
	private final String jobName = "nextcloud_apache_conf_main";
	private final String projectName = "TEST";
	public Integer errorCode = null;
	private String currentComponent = "";
	
	private String cLabel =  null;
	
		private final java.util.Map<String, Object> globalMap = new java.util.HashMap<String, Object>();
        private final static java.util.Map<String, Object> junitGlobalMap = new java.util.HashMap<String, Object>();
	
		private final java.util.Map<String, Long> start_Hash = new java.util.HashMap<String, Long>();
		private final java.util.Map<String, Long> end_Hash = new java.util.HashMap<String, Long>();
		private final java.util.Map<String, Boolean> ok_Hash = new java.util.HashMap<String, Boolean>();
		public  final java.util.List<String[]> globalBuffer = new java.util.ArrayList<String[]>();
	

private RunStat runStat = new RunStat();

	// OSGi DataSource
	private final static String KEY_DB_DATASOURCES = "KEY_DB_DATASOURCES";
	
	private final static String KEY_DB_DATASOURCES_RAW = "KEY_DB_DATASOURCES_RAW";

	public void setDataSources(java.util.Map<String, javax.sql.DataSource> dataSources) {
		java.util.Map<String, routines.system.TalendDataSource> talendDataSources = new java.util.HashMap<String, routines.system.TalendDataSource>();
		for (java.util.Map.Entry<String, javax.sql.DataSource> dataSourceEntry : dataSources.entrySet()) {
			talendDataSources.put(dataSourceEntry.getKey(), new routines.system.TalendDataSource(dataSourceEntry.getValue()));
		}
		globalMap.put(KEY_DB_DATASOURCES, talendDataSources);
		globalMap.put(KEY_DB_DATASOURCES_RAW, new java.util.HashMap<String, javax.sql.DataSource>(dataSources));
	}
	
	public void setDataSourceReferences(List serviceReferences) throws Exception{
		
		java.util.Map<String, routines.system.TalendDataSource> talendDataSources = new java.util.HashMap<String, routines.system.TalendDataSource>();
		java.util.Map<String, javax.sql.DataSource> dataSources = new java.util.HashMap<String, javax.sql.DataSource>();
		
		for (java.util.Map.Entry<String, javax.sql.DataSource> entry : BundleUtils.getServices(serviceReferences,  javax.sql.DataSource.class).entrySet()) {
                    dataSources.put(entry.getKey(), entry.getValue());
                    talendDataSources.put(entry.getKey(), new routines.system.TalendDataSource(entry.getValue()));
		}

		globalMap.put(KEY_DB_DATASOURCES, talendDataSources);
		globalMap.put(KEY_DB_DATASOURCES_RAW, new java.util.HashMap<String, javax.sql.DataSource>(dataSources));
	}


private final java.io.ByteArrayOutputStream baos = new java.io.ByteArrayOutputStream();
private final java.io.PrintStream errorMessagePS = new java.io.PrintStream(new java.io.BufferedOutputStream(baos));

public String getExceptionStackTrace() {
	if ("failure".equals(this.getStatus())) {
		errorMessagePS.flush();
		return baos.toString();
	}
	return null;
}

private Exception exception;

public Exception getException() {
	if ("failure".equals(this.getStatus())) {
		return this.exception;
	}
	return null;
}

private class TalendException extends Exception {

	private static final long serialVersionUID = 1L;

	private java.util.Map<String, Object> globalMap = null;
	private Exception e = null;
	
	private String currentComponent = null;
	private String cLabel =  null;
	
	private String virtualComponentName = null;
	
	public void setVirtualComponentName (String virtualComponentName){
		this.virtualComponentName = virtualComponentName;
	}

	private TalendException(Exception e, String errorComponent, final java.util.Map<String, Object> globalMap) {
		this.currentComponent= errorComponent;
		this.globalMap = globalMap;
		this.e = e;
	}
	
	private TalendException(Exception e, String errorComponent, String errorComponentLabel, final java.util.Map<String, Object> globalMap) {
		this(e, errorComponent, globalMap);
		this.cLabel = errorComponentLabel;
	}

	public Exception getException() {
		return this.e;
	}

	public String getCurrentComponent() {
		return this.currentComponent;
	}

	
    public String getExceptionCauseMessage(Exception e){
        Throwable cause = e;
        String message = null;
        int i = 10;
        while (null != cause && 0 < i--) {
            message = cause.getMessage();
            if (null == message) {
                cause = cause.getCause();
            } else {
                break;          
            }
        }
        if (null == message) {
            message = e.getClass().getName();
        }   
        return message;
    }

	@Override
	public void printStackTrace() {
		if (!(e instanceof TalendException || e instanceof TDieException)) {
			if(virtualComponentName!=null && currentComponent.indexOf(virtualComponentName+"_")==0){
				globalMap.put(virtualComponentName+"_ERROR_MESSAGE",getExceptionCauseMessage(e));
			}
			globalMap.put(currentComponent+"_ERROR_MESSAGE",getExceptionCauseMessage(e));
			System.err.println("Exception in component " + currentComponent + " (" + jobName + ")");
		}
		if (!(e instanceof TDieException)) {
			if(e instanceof TalendException){
				e.printStackTrace();
			} else {
				e.printStackTrace();
				e.printStackTrace(errorMessagePS);
				nextcloud_apache_conf_main.this.exception = e;
			}
		}
		if (!(e instanceof TalendException)) {
		try {
			for (java.lang.reflect.Method m : this.getClass().getEnclosingClass().getMethods()) {
				if (m.getName().compareTo(currentComponent + "_error") == 0) {
					m.invoke(nextcloud_apache_conf_main.this, new Object[] { e , currentComponent, globalMap});
					break;
				}
			}

			if(!(e instanceof TDieException)){
			}
		} catch (Exception e) {
			this.e.printStackTrace();
		}
		}
	}
}

			public void tRunJob_2_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_2_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_3_error(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {
				
				end_Hash.put(errorComponent, System.currentTimeMillis());
				
				status = "failure";
				
					tRunJob_3_onSubJobError(exception, errorComponent, globalMap);
			}
			
			public void tRunJob_2_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
			public void tRunJob_3_onSubJobError(Exception exception, String errorComponent, final java.util.Map<String, Object> globalMap) throws TalendException {

resumeUtil.addLog("SYSTEM_LOG", "NODE:"+ errorComponent, "", Thread.currentThread().getId()+ "", "FATAL", "", exception.getMessage(), ResumeUtil.getExceptionStackTrace(exception),"");

			}
	






public void tRunJob_2Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_2_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	

	
		String iterateId = "";
	
	
	String currentComponent = "";
	String cLabel =  null;
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;



		


	
	/**
	 * [tRunJob_2 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_2", false);
		start_Hash.put("tRunJob_2", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_2";
	
	
		int tos_count_tRunJob_2 = 0;
		
class DealChildJobLibrary_tRunJob_2 {

	public String replaceJarPathsFromCrcMap(String originalClassPathLine) throws java.lang.Exception {
		String classPathLine = "";
		String crcMapPath = new java.io.File("../crcMap").getCanonicalPath();
		if (isNeedAddLibsPath( crcMapPath)) {
			java.util.Map<String, String> crcMap = null;
			java.io.ObjectInputStream ois = new java.io.ObjectInputStream(new java.io.FileInputStream(crcMapPath)) {
				@Override
				public Class<?> resolveClass(java.io.ObjectStreamClass desc) throws java.io.IOException, ClassNotFoundException {
					if(!"java.util.HashMap".equals(desc.getName())) {
						throw new java.io.InvalidClassException("Unauthorized deserialization attempt : " + desc.getName());
					}
					return super.resolveClass(desc);
				}
			};
			crcMap = (java.util.Map<String, String>) ois.readObject();
			ois.close();
			classPathLine = addLibsPath(originalClassPathLine, crcMap);
		} else {
			classPathLine = originalClassPathLine;
		}
		return classPathLine;
	}
	
	private boolean isNeedAddLibsPath(String crcMapPath) {
		if (!(new java.io.File(crcMapPath).exists())) {// when not use cache
			return false;
		}
		return true;
	}
	
	
	private String addLibsPath(String line, java.util.Map<String, String> crcMap) {
		for (java.util.Map.Entry<String, String> entry : crcMap.entrySet()) {
			line = adaptLibPaths(line, entry);
		}
		return line;
	}
	
	private String adaptLibPaths(String line, java.util.Map.Entry<String, String> entry) {
		String jarName = entry.getValue();
		String crc = entry.getKey();
		String libStringFinder = "../lib/" + jarName;
		if (line.contains(libStringFinder)) {
			line = line.replace(libStringFinder, "../../../cache/lib/" + crc + "/" + jarName);
		} else if (line.contains(":$ROOT_PATH/" + jarName + ":")) {
			line = line.replace(":$ROOT_PATH/" + jarName + ":", ":$ROOT_PATH/../../../cache/lib/" + crc + "/" + jarName + ":");
		} else if (line.contains(";" + jarName + ";")) {
			line = line.replace(";" + jarName + ";", ";../../../cache/lib/" + crc + "/" + jarName + ";");
		}
		return line;
	}
	
}
	DealChildJobLibrary_tRunJob_2 dealChildJobLibrary_tRunJob_2 = new DealChildJobLibrary_tRunJob_2();

	class JVMArgumentHelper_tRunJob_2 {
		
		
		
		private void addClasspath(java.util.List<String> target_argument_list, String job_origin_classpath) {
			
			String extra_classpath = null;
			String path_separator = System.getProperty("path.separator");
			if (path_separator != null && path_separator.length() > 1) {
				throw new RuntimeException("path separator should be single character");
			}
			
			if(extra_classpath!=null && !extra_classpath.isEmpty()) {
				if(extra_classpath.endsWith(path_separator)) {
					target_argument_list.add(extra_classpath+job_origin_classpath);
				} else if(extra_classpath.contains(path_separator)) {
					target_argument_list.add(concatStr(extra_classpath, path_separator, job_origin_classpath));
				} else if(extra_classpath.endsWith(":")) {
					target_argument_list.add(extra_classpath.replace(":", path_separator)+job_origin_classpath);
				} else if(extra_classpath.endsWith(";")) {
					target_argument_list.add(extra_classpath.replace(";", path_separator)+job_origin_classpath);
				} else if(extra_classpath.contains(":")) {
					target_argument_list.add(concatStr(extra_classpath.replace(":", path_separator), path_separator, job_origin_classpath));
				} else if(extra_classpath.contains(";")) {
					target_argument_list.add(concatStr(extra_classpath.replace(";", path_separator), path_separator, job_origin_classpath));
				} else {
					target_argument_list.add(concatStr(extra_classpath, path_separator, job_origin_classpath));
				}
				return;
			}
			
			target_argument_list.add(job_origin_classpath);
		}
		
		private String concatStr(String s1, String s2, String s3) {
			java.lang.StringBuilder strB = new java.lang.StringBuilder();
			strB.append(s1).append(s2).append(s3);
			return strB.toString();
		}
		
		public void addArgumentsTo(java.util.List<String> target_argument_list, String argument_from_child) {
			addArgumentsTo(target_argument_list, argument_from_child, false);
		}
		
		public void addArgumentsTo(java.util.List<String> target_argument_list, String argument_from_child, boolean isCP) {
			if(isCP) {
				addClasspath(target_argument_list, argument_from_child);
				return;
			}
		
			
			
			
			target_argument_list.add(argument_from_child);
			
		}
		
		
	}
	
	JVMArgumentHelper_tRunJob_2 jvm_argument_helper_tRunJob_2 = new JVMArgumentHelper_tRunJob_2();
	
	String audit_jar_path_tRunJob_2 = System.getProperty("classpath.extended");
	

 



/**
 * [tRunJob_2 begin ] stop
 */
	
	/**
	 * [tRunJob_2 main ] start
	 */

	

	
	
	currentComponent="tRunJob_2";
	
	
	java.util.List<String> paraList_tRunJob_2 = new java.util.ArrayList<String>();
	
			
			String osName_tRunJob_2 = System.getProperty("os.name");
			if (osName_tRunJob_2 != null && osName_tRunJob_2.toLowerCase(java.util.Locale.US).startsWith("win")){
				
						paraList_tRunJob_2.add("java");
						String m2 = System.getProperty("talend.component.manager.m2.repository");
						if (m2 != null){
							paraList_tRunJob_2.add("-Dtalend.component.manager.m2.repository=" + m2);
						}
						
						if (Boolean.getBoolean("propagateLoggingConfiguration")) {
							String log4j1_config_tRunJob_2 = System.getProperty("log4j.configuration");
							if (log4j1_config_tRunJob_2 != null){
								paraList_tRunJob_2.add("-Dlog4j.configuration=" + log4j1_config_tRunJob_2);
							}
							String log4j2_config_tRunJob_2 = System.getProperty("log4j.configurationFile");
							if (log4j2_config_tRunJob_2 != null){
								paraList_tRunJob_2.add("-Dlog4j.configurationFile=" + log4j2_config_tRunJob_2);
							}
							if (log4j1_config_tRunJob_2 != null || log4j2_config_tRunJob_2 != null) {
								paraList_tRunJob_2.add("-DpropagateLoggingConfiguration=true");
							}
						}
						
						if(enableLogStash){
							System.getProperties().stringPropertyNames().stream()
								.filter(it -> it.startsWith("audit."))
								.forEach(key -> paraList_tRunJob_2.add("-D" + key + "=" + System.getProperty(key)));
						}
							
						System.getProperties().stringPropertyNames().stream()
							.filter(it -> it.startsWith("runtime.lineage.") || "classpath.extended".equals(it))
							.forEach(key -> paraList_tRunJob_2.add("-D" + key + "=" + System.getProperty(key)));
					
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "-Dtalend.component.manager.m2.repository=../lib");
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "-Xms256M");
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "-Xmx1024M");
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "-cp");
		      				
              					String classpath_tRunJob_2_5 = ".;../lib/routines.jar;../lib/jaxb-api-2.3.1.jar;../lib/log4j-slf4j-impl-2.17.1.jar;../lib/log4j-api-2.17.1.jar;../lib/log4j-core-2.17.1.jar;../lib/log4j-1.2-api-2.17.1.jar;../lib/cxf-rt-features-logging-3.5.5.jar;../lib/stax2-api-4.2.1.jar;../lib/commons-codec-1.15.jar;../lib/cxf-core-3.5.5.jar;../lib/wss4j-policy-2.4.1.jar;../lib/opensaml-security-api-3.4.6.jar;../lib/opensaml-soap-api-3.4.6.jar;../lib/spring-context-5.3.29.jar;../lib/ehcache-3.9.3.jar;../lib/opensaml-profile-api-3.4.6.jar;../lib/org.apache.servicemix.specs.jaxws-api-2.2-2.9.0.jar;../lib/spring-expression-5.3.29.jar;../lib/javax.ws.rs-api-2.1.jar;../lib/jaxb-runtime-2.3.2.jar;../lib/cxf-rt-security-saml-3.5.5.jar;../lib/wss4j-ws-security-policy-stax-2.4.1.jar;../lib/cxf-rt-rs-client-3.5.5.jar;../lib/cxf-rt-rs-extension-providers-3.5.5.jar;../lib/opensaml-saml-api-3.4.6.jar;../lib/jakarta.jws-api-2.1.0.jar;../lib/opensaml-saml-impl-3.4.6.jar;../lib/spring-web-5.3.29.jar;../lib/opensaml-security-impl-3.4.6.jar;../lib/spring-core-5.3.29.jar;../lib/cxf-rt-transports-http-3.5.5.jar;../lib/jakarta.annotation-api-1.3.5.jar;../lib/opensaml-xacml-saml-impl-3.4.6.jar;../lib/commons-collections-3.2.2.jar;../lib/jasypt-1.9.3.jar;../lib/txw2-2.3.3.jar;../lib/joda-time-2.10.10.jar;../lib/bcprov-jdk18on-1.74.jar;../lib/commons-logging-1.2.jar;../lib/opensaml-core-3.4.6.jar;../lib/cxf-rt-ws-security-3.5.5.jar;../lib/wss4j-ws-security-stax-2.4.1.jar;../lib/wss4j-ws-security-dom-2.4.1.jar;../lib/javax.activation-1.2.0.jar;../lib/spring-aop-5.3.29.jar;../lib/opensaml-xacml-saml-api-3.4.6.jar;../lib/cxf-rt-wsdl-3.5.5.jar;../lib/security-common-8.8.8-SNAPSHOT.jar;../lib/wss4j-bindings-2.4.1.jar;../lib/neethi-3.1.1.jar;../lib/cxf-rt-bindings-soap-3.5.5.jar;../lib/istack-commons-runtime-3.0.10.jar;../lib/opensaml-xmlsec-impl-3.4.6.jar;../lib/jettison-1.5.4.jar;../lib/opensaml-xacml-api-3.4.6.jar;../lib/xmlschema-core-2.2.5.jar;../lib/jakarta.xml.bind-api-2.3.3.jar;../lib/woodstox-core-6.4.0.jar;../lib/aopalliance-1.0.jar;../lib/stax-ex-1.8.3.jar;../lib/opensaml-xacml-impl-3.4.6.jar;../lib/spring-webmvc-5.3.29.jar;../lib/guava-32.0.1-jre.jar;../lib/cxf-rt-security-3.5.5.jar;../lib/wss4j-ws-security-common-2.4.1.jar;../lib/jaxen-1.1.6.jar;../lib/cxf-rt-databinding-jaxb-3.5.5.jar;../lib/cryptacular-1.2.5.jar;../lib/cxf-rt-rs-security-oauth2-3.5.5.jar;../lib/spring-beans-5.3.29.jar;../lib/wsdl4j-1.6.3.jar;../lib/cxf-rt-frontend-jaxrs-3.5.5.jar;../lib/xmlsec-2.2.3.jar;../lib/jakarta.xml.soap-api-1.4.1.jar;../lib/opensaml-xmlsec-api-3.4.6.jar;../lib/oro-2.0.8.jar;../lib/postgresql-42.6.0.jar;../lib/jboss-marshalling-river-2.0.12.Final.jar;../lib/trove-1.0.2.jar;../lib/jboss-marshalling-2.0.12.Final.jar;../lib/advancedPersistentLookupLib-1.5.jar;../lib/slf4j-api-1.7.34.jar;../lib/dom4j-2.1.3.jar;../lib/crypto-utils-7.1.16.jar;../lib/talendcsv-1.1.0.jar;nextcloud_apache_conf_create_shares_0_1.jar;";
              					
              					if(audit_jar_path_tRunJob_2!=null && !audit_jar_path_tRunJob_2.isEmpty()) {
		      						classpath_tRunJob_2_5 += audit_jar_path_tRunJob_2;
		      					}
		      					
	        					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, dealChildJobLibrary_tRunJob_2.replaceJarPathsFromCrcMap(classpath_tRunJob_2_5), true);
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "test.nextcloud_apache_conf_create_shares_0_1.nextcloud_apache_conf_create_shares");
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "--father_pid="+pid);
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "--root_pid="+rootPid);
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "--father_node=tRunJob_2");
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "--context=Default");
		      				
		      					jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "%*");
		      				
			} else {
	      		
						paraList_tRunJob_2.add("java");
						String m2 = System.getProperty("talend.component.manager.m2.repository");
						if (m2 != null){
							paraList_tRunJob_2.add("-Dtalend.component.manager.m2.repository=" + m2);
						}
						
						if (Boolean.getBoolean("propagateLoggingConfiguration")) {
							String log4j1_config_tRunJob_2 = System.getProperty("log4j.configuration");
							if (log4j1_config_tRunJob_2 != null){
								paraList_tRunJob_2.add("-Dlog4j.configuration=" + log4j1_config_tRunJob_2);
							}
							String log4j2_config_tRunJob_2 = System.getProperty("log4j.configurationFile");
							if (log4j2_config_tRunJob_2 != null){
								paraList_tRunJob_2.add("-Dlog4j.configurationFile=" + log4j2_config_tRunJob_2);
							}
							if (log4j1_config_tRunJob_2 != null || log4j2_config_tRunJob_2 != null) {
								paraList_tRunJob_2.add("-DpropagateLoggingConfiguration=true");
							}
						}
						
						if(enableLogStash){
							System.getProperties().stringPropertyNames().stream()
								.filter(it -> it.startsWith("audit."))
								.forEach(key -> paraList_tRunJob_2.add("-D" + key + "=" + System.getProperty(key)));
						}
							
						System.getProperties().stringPropertyNames().stream()
							.filter(it -> it.startsWith("runtime.lineage.") || "classpath.extended".equals(it))
							.forEach(key -> paraList_tRunJob_2.add("-D" + key + "=" + System.getProperty(key)));
					
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "-Dtalend.component.manager.m2.repository=../lib");
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "-Xms256M");
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "-Xmx1024M");
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "-cp");
		      				
		      					String classpath_tRunJob_2_5 = ".:$ROOT_PATH:$ROOT_PATH/../lib/routines.jar:$ROOT_PATH/../lib/jaxb-api-2.3.1.jar:$ROOT_PATH/../lib/log4j-slf4j-impl-2.17.1.jar:$ROOT_PATH/../lib/log4j-api-2.17.1.jar:$ROOT_PATH/../lib/log4j-core-2.17.1.jar:$ROOT_PATH/../lib/log4j-1.2-api-2.17.1.jar:$ROOT_PATH/../lib/cxf-rt-features-logging-3.5.5.jar:$ROOT_PATH/../lib/stax2-api-4.2.1.jar:$ROOT_PATH/../lib/commons-codec-1.15.jar:$ROOT_PATH/../lib/cxf-core-3.5.5.jar:$ROOT_PATH/../lib/wss4j-policy-2.4.1.jar:$ROOT_PATH/../lib/opensaml-security-api-3.4.6.jar:$ROOT_PATH/../lib/opensaml-soap-api-3.4.6.jar:$ROOT_PATH/../lib/spring-context-5.3.29.jar:$ROOT_PATH/../lib/ehcache-3.9.3.jar:$ROOT_PATH/../lib/opensaml-profile-api-3.4.6.jar:$ROOT_PATH/../lib/org.apache.servicemix.specs.jaxws-api-2.2-2.9.0.jar:$ROOT_PATH/../lib/spring-expression-5.3.29.jar:$ROOT_PATH/../lib/javax.ws.rs-api-2.1.jar:$ROOT_PATH/../lib/jaxb-runtime-2.3.2.jar:$ROOT_PATH/../lib/cxf-rt-security-saml-3.5.5.jar:$ROOT_PATH/../lib/wss4j-ws-security-policy-stax-2.4.1.jar:$ROOT_PATH/../lib/cxf-rt-rs-client-3.5.5.jar:$ROOT_PATH/../lib/cxf-rt-rs-extension-providers-3.5.5.jar:$ROOT_PATH/../lib/opensaml-saml-api-3.4.6.jar:$ROOT_PATH/../lib/jakarta.jws-api-2.1.0.jar:$ROOT_PATH/../lib/opensaml-saml-impl-3.4.6.jar:$ROOT_PATH/../lib/spring-web-5.3.29.jar:$ROOT_PATH/../lib/opensaml-security-impl-3.4.6.jar:$ROOT_PATH/../lib/spring-core-5.3.29.jar:$ROOT_PATH/../lib/cxf-rt-transports-http-3.5.5.jar:$ROOT_PATH/../lib/jakarta.annotation-api-1.3.5.jar:$ROOT_PATH/../lib/opensaml-xacml-saml-impl-3.4.6.jar:$ROOT_PATH/../lib/commons-collections-3.2.2.jar:$ROOT_PATH/../lib/jasypt-1.9.3.jar:$ROOT_PATH/../lib/txw2-2.3.3.jar:$ROOT_PATH/../lib/joda-time-2.10.10.jar:$ROOT_PATH/../lib/bcprov-jdk18on-1.74.jar:$ROOT_PATH/../lib/commons-logging-1.2.jar:$ROOT_PATH/../lib/opensaml-core-3.4.6.jar:$ROOT_PATH/../lib/cxf-rt-ws-security-3.5.5.jar:$ROOT_PATH/../lib/wss4j-ws-security-stax-2.4.1.jar:$ROOT_PATH/../lib/wss4j-ws-security-dom-2.4.1.jar:$ROOT_PATH/../lib/javax.activation-1.2.0.jar:$ROOT_PATH/../lib/spring-aop-5.3.29.jar:$ROOT_PATH/../lib/opensaml-xacml-saml-api-3.4.6.jar:$ROOT_PATH/../lib/cxf-rt-wsdl-3.5.5.jar:$ROOT_PATH/../lib/security-common-8.8.8-SNAPSHOT.jar:$ROOT_PATH/../lib/wss4j-bindings-2.4.1.jar:$ROOT_PATH/../lib/neethi-3.1.1.jar:$ROOT_PATH/../lib/cxf-rt-bindings-soap-3.5.5.jar:$ROOT_PATH/../lib/istack-commons-runtime-3.0.10.jar:$ROOT_PATH/../lib/opensaml-xmlsec-impl-3.4.6.jar:$ROOT_PATH/../lib/jettison-1.5.4.jar:$ROOT_PATH/../lib/opensaml-xacml-api-3.4.6.jar:$ROOT_PATH/../lib/xmlschema-core-2.2.5.jar:$ROOT_PATH/../lib/jakarta.xml.bind-api-2.3.3.jar:$ROOT_PATH/../lib/woodstox-core-6.4.0.jar:$ROOT_PATH/../lib/aopalliance-1.0.jar:$ROOT_PATH/../lib/stax-ex-1.8.3.jar:$ROOT_PATH/../lib/opensaml-xacml-impl-3.4.6.jar:$ROOT_PATH/../lib/spring-webmvc-5.3.29.jar:$ROOT_PATH/../lib/guava-32.0.1-jre.jar:$ROOT_PATH/../lib/cxf-rt-security-3.5.5.jar:$ROOT_PATH/../lib/wss4j-ws-security-common-2.4.1.jar:$ROOT_PATH/../lib/jaxen-1.1.6.jar:$ROOT_PATH/../lib/cxf-rt-databinding-jaxb-3.5.5.jar:$ROOT_PATH/../lib/cryptacular-1.2.5.jar:$ROOT_PATH/../lib/cxf-rt-rs-security-oauth2-3.5.5.jar:$ROOT_PATH/../lib/spring-beans-5.3.29.jar:$ROOT_PATH/../lib/wsdl4j-1.6.3.jar:$ROOT_PATH/../lib/cxf-rt-frontend-jaxrs-3.5.5.jar:$ROOT_PATH/../lib/xmlsec-2.2.3.jar:$ROOT_PATH/../lib/jakarta.xml.soap-api-1.4.1.jar:$ROOT_PATH/../lib/opensaml-xmlsec-api-3.4.6.jar:$ROOT_PATH/../lib/oro-2.0.8.jar:$ROOT_PATH/../lib/postgresql-42.6.0.jar:$ROOT_PATH/../lib/jboss-marshalling-river-2.0.12.Final.jar:$ROOT_PATH/../lib/trove-1.0.2.jar:$ROOT_PATH/../lib/jboss-marshalling-2.0.12.Final.jar:$ROOT_PATH/../lib/advancedPersistentLookupLib-1.5.jar:$ROOT_PATH/../lib/slf4j-api-1.7.34.jar:$ROOT_PATH/../lib/dom4j-2.1.3.jar:$ROOT_PATH/../lib/crypto-utils-7.1.16.jar:$ROOT_PATH/../lib/talendcsv-1.1.0.jar:$ROOT_PATH/nextcloud_apache_conf_create_shares_0_1.jar:";
		      					
		      					if(audit_jar_path_tRunJob_2!=null && !audit_jar_path_tRunJob_2.isEmpty()) {
		      						classpath_tRunJob_2_5 += audit_jar_path_tRunJob_2;
		      					}
		      					
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, dealChildJobLibrary_tRunJob_2.replaceJarPathsFromCrcMap(classpath_tRunJob_2_5).replace("$ROOT_PATH",System.getProperty("user.dir")), true);
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "test.nextcloud_apache_conf_create_shares_0_1.nextcloud_apache_conf_create_shares");
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "--father_pid="+pid);
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "--root_pid="+rootPid);
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "--father_node=tRunJob_2");
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "--context=Default");
		      				
								jvm_argument_helper_tRunJob_2.addArgumentsTo(paraList_tRunJob_2, "$@");
		      				
			}

			
			
	  	
		if(enableLogStash){
			paraList_tRunJob_2.add("--audit.enabled="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_2.add("--stat_port=" + null);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_2.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_2 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_2 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_2".equals(tRunJobName_tRunJob_2) && childResumePath_tRunJob_2 != null){
		paraList_tRunJob_2.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_2.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_2");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_2 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_2 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_2.put("ncApacheConfDir", context.ncApacheConfDir);
                    paraList_tRunJob_2.add("--context_type " + "ncApacheConfDir" + "=" + "id_Directory");
                    parentContextMap_tRunJob_2.put("ncHost", context.ncHost);
                    paraList_tRunJob_2.add("--context_type " + "ncHost" + "=" + "id_String");
                    parentContextMap_tRunJob_2.put("ncPassword", context.ncPassword);
                    paraList_tRunJob_2.add("--context_type " + "ncPassword" + "=" + "id_Password");
                    parentContextMap_tRunJob_2.put("ncRevProxy", context.ncRevProxy);
                    paraList_tRunJob_2.add("--context_type " + "ncRevProxy" + "=" + "id_String");
                    parentContextMap_tRunJob_2.put("ncUsername", context.ncUsername);
                    paraList_tRunJob_2.add("--context_type " + "ncUsername" + "=" + "id_String");
                    parentContextMap_tRunJob_2.put("pgDatabase", context.pgDatabase);
                    paraList_tRunJob_2.add("--context_type " + "pgDatabase" + "=" + "id_String");
                    parentContextMap_tRunJob_2.put("pgHost", context.pgHost);
                    paraList_tRunJob_2.add("--context_type " + "pgHost" + "=" + "id_String");
                    parentContextMap_tRunJob_2.put("pgPassword", context.pgPassword);
                    paraList_tRunJob_2.add("--context_type " + "pgPassword" + "=" + "id_Password");
                    parentContextMap_tRunJob_2.put("pgPort", context.pgPort);
                    paraList_tRunJob_2.add("--context_type " + "pgPort" + "=" + "id_String");
                    parentContextMap_tRunJob_2.put("pgSchema", context.pgSchema);
                    paraList_tRunJob_2.add("--context_type " + "pgSchema" + "=" + "id_String");
                    parentContextMap_tRunJob_2.put("pgUsername", context.pgUsername);
                    paraList_tRunJob_2.add("--context_type " + "pgUsername" + "=" + "id_String");
                    parentContextMap_tRunJob_2.put("ncRemoveAllShares", context.ncRemoveAllShares);
                    paraList_tRunJob_2.add("--context_type " + "ncRemoveAllShares" + "=" + "id_Integer");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_2().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_2 = context.propertyNames();
		while (propertyNames_tRunJob_2.hasMoreElements()) {
			String key_tRunJob_2 = (String) propertyNames_tRunJob_2.nextElement();
			Object value_tRunJob_2 = (Object) context.get(key_tRunJob_2);
			if(value_tRunJob_2!=null) {  
				
					paraList_tRunJob_2.add("--context_param " + key_tRunJob_2 + "=" + value_tRunJob_2);
					
			} else {
				paraList_tRunJob_2.add("--context_param " + key_tRunJob_2 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_2 = null;

	
	
				class ConsoleHelper_tRunJob_2 {
					private Thread getNormalThread(Process process) {
						return new Thread() {
							public void run() {
								try {
									java.io.BufferedReader reader = new java.io.BufferedReader(
											new java.io.InputStreamReader(
													process.getInputStream()));
									String line = "";
									try {
										while ((line = reader.readLine()) != null) {
											System.out.println(line);
										}
									} finally {
										reader.close();
									}
								} catch (java.io.IOException ioe) {
globalMap.put("tRunJob_2_ERROR_MESSAGE",ioe.getMessage());
						            
									ioe.printStackTrace();
								}
							}
						};
					}

					private Thread getErrorThread(Process process, StringBuffer sb) {
						return new Thread() {
							public void run() {
								try {
									java.io.BufferedReader reader = new java.io.BufferedReader(
											new java.io.InputStreamReader(
													process.getErrorStream()));
									String line = "";
									try {
										while ((line = reader.readLine()) != null) {
											sb.append(line)
													.append("\n");
										}
									} finally {
										reader.close();
									}
								} catch (java.io.IOException ioe) {
globalMap.put("tRunJob_2_ERROR_MESSAGE",ioe.getMessage());
						            
									ioe.printStackTrace();
								}
							}
						};
					}
				}
				ConsoleHelper_tRunJob_2 consoleHelper_tRunJob_2 = new ConsoleHelper_tRunJob_2();

		Runtime runtime_tRunJob_2 = Runtime.getRuntime();
		Process ps_tRunJob_2 = null;
		
		//0 indicates normal termination
        int result_tRunJob_2;
        StringBuffer errorMsg_tRunJob_2 = new StringBuffer();
        try {
            ps_tRunJob_2 = runtime_tRunJob_2.exec((String[])paraList_tRunJob_2.toArray(new String[paraList_tRunJob_2.size()]));

            Thread normal_tRunJob_2 = consoleHelper_tRunJob_2.getNormalThread(ps_tRunJob_2);
            normal_tRunJob_2.start();

            Thread error_tRunJob_2 = consoleHelper_tRunJob_2.getErrorThread(ps_tRunJob_2, errorMsg_tRunJob_2);
            error_tRunJob_2.start();

            result_tRunJob_2 = ps_tRunJob_2.waitFor();
            normal_tRunJob_2.join();
            error_tRunJob_2.join();
        } catch (ThreadDeath tde) {
globalMap.put("tRunJob_2_ERROR_MESSAGE",tde.getMessage());
            ps_tRunJob_2.destroy();
            throw tde;
        }

		globalMap.put("tRunJob_2_CHILD_RETURN_CODE",result_tRunJob_2);
		if(result_tRunJob_2 != 0){
   			globalMap.put("tRunJob_2_CHILD_EXCEPTION_STACKTRACE",errorMsg_tRunJob_2.toString());
			
				
				System.err.println("Child job returns " + result_tRunJob_2 + ". It doesn't terminate normally.\n" + errorMsg_tRunJob_2.toString());
			
  		}

		

 


	tos_count_tRunJob_2++;

/**
 * [tRunJob_2 main ] stop
 */
	
	/**
	 * [tRunJob_2 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_2";
	
	

 



/**
 * [tRunJob_2 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_2 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_2";
	
	

 



/**
 * [tRunJob_2 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_2 end ] start
	 */

	

	
	
	currentComponent="tRunJob_2";
	
	

 

ok_Hash.put("tRunJob_2", true);
end_Hash.put("tRunJob_2", System.currentTimeMillis());




/**
 * [tRunJob_2 end ] stop
 */
				}//end the resume

				
				    			if(resumeEntryMethodName == null || globalResumeTicket){
				    				resumeUtil.addLog("CHECKPOINT", "CONNECTION:SUBJOB_OK:tRunJob_2:OnSubjobOk", "", Thread.currentThread().getId() + "", "", "", "", "", "");
								}	    				    			
					    	
								if(execStat){    	
									runStat.updateStatOnConnection("OnSubjobOk1", 0, "ok");
								} 
							
							tRunJob_3Process(globalMap); 
						



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, cLabel, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_2 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_2";
	
	
	
 



/**
 * [tRunJob_2 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_2_SUBPROCESS_STATE", 1);
	}
	


public void tRunJob_3Process(final java.util.Map<String, Object> globalMap) throws TalendException {
	globalMap.put("tRunJob_3_SUBPROCESS_STATE", 0);

 final boolean execStat = this.execStat;
	

	
		String iterateId = "";
	
	
	String currentComponent = "";
	String cLabel =  null;
	java.util.Map<String, Object> resourceMap = new java.util.HashMap<String, Object>();

	try {
			// TDI-39566 avoid throwing an useless Exception
			boolean resumeIt = true;
			if (globalResumeTicket == false && resumeEntryMethodName != null) {
				String currentMethodName = new java.lang.Exception().getStackTrace()[0].getMethodName();
				resumeIt = resumeEntryMethodName.equals(currentMethodName);
			}
			if (resumeIt || globalResumeTicket) { //start the resume
				globalResumeTicket = true;





	
	/**
	 * [tRunJob_3 begin ] start
	 */

	

	
		
		ok_Hash.put("tRunJob_3", false);
		start_Hash.put("tRunJob_3", System.currentTimeMillis());
		
	
	currentComponent="tRunJob_3";
	
	
		int tos_count_tRunJob_3 = 0;
		
class DealChildJobLibrary_tRunJob_3 {

	public String replaceJarPathsFromCrcMap(String originalClassPathLine) throws java.lang.Exception {
		String classPathLine = "";
		String crcMapPath = new java.io.File("../crcMap").getCanonicalPath();
		if (isNeedAddLibsPath( crcMapPath)) {
			java.util.Map<String, String> crcMap = null;
			java.io.ObjectInputStream ois = new java.io.ObjectInputStream(new java.io.FileInputStream(crcMapPath)) {
				@Override
				public Class<?> resolveClass(java.io.ObjectStreamClass desc) throws java.io.IOException, ClassNotFoundException {
					if(!"java.util.HashMap".equals(desc.getName())) {
						throw new java.io.InvalidClassException("Unauthorized deserialization attempt : " + desc.getName());
					}
					return super.resolveClass(desc);
				}
			};
			crcMap = (java.util.Map<String, String>) ois.readObject();
			ois.close();
			classPathLine = addLibsPath(originalClassPathLine, crcMap);
		} else {
			classPathLine = originalClassPathLine;
		}
		return classPathLine;
	}
	
	private boolean isNeedAddLibsPath(String crcMapPath) {
		if (!(new java.io.File(crcMapPath).exists())) {// when not use cache
			return false;
		}
		return true;
	}
	
	
	private String addLibsPath(String line, java.util.Map<String, String> crcMap) {
		for (java.util.Map.Entry<String, String> entry : crcMap.entrySet()) {
			line = adaptLibPaths(line, entry);
		}
		return line;
	}
	
	private String adaptLibPaths(String line, java.util.Map.Entry<String, String> entry) {
		String jarName = entry.getValue();
		String crc = entry.getKey();
		String libStringFinder = "../lib/" + jarName;
		if (line.contains(libStringFinder)) {
			line = line.replace(libStringFinder, "../../../cache/lib/" + crc + "/" + jarName);
		} else if (line.contains(":$ROOT_PATH/" + jarName + ":")) {
			line = line.replace(":$ROOT_PATH/" + jarName + ":", ":$ROOT_PATH/../../../cache/lib/" + crc + "/" + jarName + ":");
		} else if (line.contains(";" + jarName + ";")) {
			line = line.replace(";" + jarName + ";", ";../../../cache/lib/" + crc + "/" + jarName + ";");
		}
		return line;
	}
	
}
	DealChildJobLibrary_tRunJob_3 dealChildJobLibrary_tRunJob_3 = new DealChildJobLibrary_tRunJob_3();

	class JVMArgumentHelper_tRunJob_3 {
		
		
		
		private void addClasspath(java.util.List<String> target_argument_list, String job_origin_classpath) {
			
			String extra_classpath = null;
			String path_separator = System.getProperty("path.separator");
			if (path_separator != null && path_separator.length() > 1) {
				throw new RuntimeException("path separator should be single character");
			}
			
			if(extra_classpath!=null && !extra_classpath.isEmpty()) {
				if(extra_classpath.endsWith(path_separator)) {
					target_argument_list.add(extra_classpath+job_origin_classpath);
				} else if(extra_classpath.contains(path_separator)) {
					target_argument_list.add(concatStr(extra_classpath, path_separator, job_origin_classpath));
				} else if(extra_classpath.endsWith(":")) {
					target_argument_list.add(extra_classpath.replace(":", path_separator)+job_origin_classpath);
				} else if(extra_classpath.endsWith(";")) {
					target_argument_list.add(extra_classpath.replace(";", path_separator)+job_origin_classpath);
				} else if(extra_classpath.contains(":")) {
					target_argument_list.add(concatStr(extra_classpath.replace(":", path_separator), path_separator, job_origin_classpath));
				} else if(extra_classpath.contains(";")) {
					target_argument_list.add(concatStr(extra_classpath.replace(";", path_separator), path_separator, job_origin_classpath));
				} else {
					target_argument_list.add(concatStr(extra_classpath, path_separator, job_origin_classpath));
				}
				return;
			}
			
			target_argument_list.add(job_origin_classpath);
		}
		
		private String concatStr(String s1, String s2, String s3) {
			java.lang.StringBuilder strB = new java.lang.StringBuilder();
			strB.append(s1).append(s2).append(s3);
			return strB.toString();
		}
		
		public void addArgumentsTo(java.util.List<String> target_argument_list, String argument_from_child) {
			addArgumentsTo(target_argument_list, argument_from_child, false);
		}
		
		public void addArgumentsTo(java.util.List<String> target_argument_list, String argument_from_child, boolean isCP) {
			if(isCP) {
				addClasspath(target_argument_list, argument_from_child);
				return;
			}
		
			
			
			
			target_argument_list.add(argument_from_child);
			
		}
		
		
	}
	
	JVMArgumentHelper_tRunJob_3 jvm_argument_helper_tRunJob_3 = new JVMArgumentHelper_tRunJob_3();
	
	String audit_jar_path_tRunJob_3 = System.getProperty("classpath.extended");
	

 



/**
 * [tRunJob_3 begin ] stop
 */
	
	/**
	 * [tRunJob_3 main ] start
	 */

	

	
	
	currentComponent="tRunJob_3";
	
	
	java.util.List<String> paraList_tRunJob_3 = new java.util.ArrayList<String>();
	
			
			String osName_tRunJob_3 = System.getProperty("os.name");
			if (osName_tRunJob_3 != null && osName_tRunJob_3.toLowerCase(java.util.Locale.US).startsWith("win")){
				
						paraList_tRunJob_3.add("java");
						String m2 = System.getProperty("talend.component.manager.m2.repository");
						if (m2 != null){
							paraList_tRunJob_3.add("-Dtalend.component.manager.m2.repository=" + m2);
						}
						
						if (Boolean.getBoolean("propagateLoggingConfiguration")) {
							String log4j1_config_tRunJob_3 = System.getProperty("log4j.configuration");
							if (log4j1_config_tRunJob_3 != null){
								paraList_tRunJob_3.add("-Dlog4j.configuration=" + log4j1_config_tRunJob_3);
							}
							String log4j2_config_tRunJob_3 = System.getProperty("log4j.configurationFile");
							if (log4j2_config_tRunJob_3 != null){
								paraList_tRunJob_3.add("-Dlog4j.configurationFile=" + log4j2_config_tRunJob_3);
							}
							if (log4j1_config_tRunJob_3 != null || log4j2_config_tRunJob_3 != null) {
								paraList_tRunJob_3.add("-DpropagateLoggingConfiguration=true");
							}
						}
						
						if(enableLogStash){
							System.getProperties().stringPropertyNames().stream()
								.filter(it -> it.startsWith("audit."))
								.forEach(key -> paraList_tRunJob_3.add("-D" + key + "=" + System.getProperty(key)));
						}
							
						System.getProperties().stringPropertyNames().stream()
							.filter(it -> it.startsWith("runtime.lineage.") || "classpath.extended".equals(it))
							.forEach(key -> paraList_tRunJob_3.add("-D" + key + "=" + System.getProperty(key)));
					
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "-Dtalend.component.manager.m2.repository=../lib");
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "-Xms256M");
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "-Xmx1024M");
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "-cp");
		      				
              					String classpath_tRunJob_3_5 = ".;../lib/routines.jar;../lib/log4j-slf4j-impl-2.17.1.jar;../lib/log4j-api-2.17.1.jar;../lib/log4j-core-2.17.1.jar;../lib/log4j-1.2-api-2.17.1.jar;../lib/cxf-rt-features-logging-3.5.5.jar;../lib/stax2-api-4.2.1.jar;../lib/commons-codec-1.15.jar;../lib/cxf-core-3.5.5.jar;../lib/wss4j-policy-2.4.1.jar;../lib/opensaml-security-api-3.4.6.jar;../lib/opensaml-soap-api-3.4.6.jar;../lib/spring-context-5.3.29.jar;../lib/ehcache-3.9.3.jar;../lib/opensaml-profile-api-3.4.6.jar;../lib/org.apache.servicemix.specs.jaxws-api-2.2-2.9.0.jar;../lib/spring-expression-5.3.29.jar;../lib/javax.ws.rs-api-2.1.jar;../lib/jaxb-runtime-2.3.2.jar;../lib/cxf-rt-security-saml-3.5.5.jar;../lib/wss4j-ws-security-policy-stax-2.4.1.jar;../lib/cxf-rt-rs-client-3.5.5.jar;../lib/cxf-rt-rs-extension-providers-3.5.5.jar;../lib/opensaml-saml-api-3.4.6.jar;../lib/jakarta.jws-api-2.1.0.jar;../lib/opensaml-saml-impl-3.4.6.jar;../lib/spring-web-5.3.29.jar;../lib/opensaml-security-impl-3.4.6.jar;../lib/spring-core-5.3.29.jar;../lib/cxf-rt-transports-http-3.5.5.jar;../lib/jakarta.annotation-api-1.3.5.jar;../lib/opensaml-xacml-saml-impl-3.4.6.jar;../lib/commons-collections-3.2.2.jar;../lib/jasypt-1.9.3.jar;../lib/txw2-2.3.3.jar;../lib/joda-time-2.10.10.jar;../lib/bcprov-jdk18on-1.74.jar;../lib/commons-logging-1.2.jar;../lib/opensaml-core-3.4.6.jar;../lib/cxf-rt-ws-security-3.5.5.jar;../lib/wss4j-ws-security-stax-2.4.1.jar;../lib/wss4j-ws-security-dom-2.4.1.jar;../lib/javax.activation-1.2.0.jar;../lib/spring-aop-5.3.29.jar;../lib/opensaml-xacml-saml-api-3.4.6.jar;../lib/cxf-rt-wsdl-3.5.5.jar;../lib/security-common-8.8.8-SNAPSHOT.jar;../lib/wss4j-bindings-2.4.1.jar;../lib/neethi-3.1.1.jar;../lib/cxf-rt-bindings-soap-3.5.5.jar;../lib/istack-commons-runtime-3.0.10.jar;../lib/opensaml-xmlsec-impl-3.4.6.jar;../lib/jettison-1.5.4.jar;../lib/opensaml-xacml-api-3.4.6.jar;../lib/xmlschema-core-2.2.5.jar;../lib/jakarta.xml.bind-api-2.3.3.jar;../lib/woodstox-core-6.4.0.jar;../lib/aopalliance-1.0.jar;../lib/stax-ex-1.8.3.jar;../lib/opensaml-xacml-impl-3.4.6.jar;../lib/spring-webmvc-5.3.29.jar;../lib/guava-32.0.1-jre.jar;../lib/cxf-rt-security-3.5.5.jar;../lib/wss4j-ws-security-common-2.4.1.jar;../lib/jaxen-1.1.6.jar;../lib/cxf-rt-databinding-jaxb-3.5.5.jar;../lib/cryptacular-1.2.5.jar;../lib/cxf-rt-rs-security-oauth2-3.5.5.jar;../lib/spring-beans-5.3.29.jar;../lib/wsdl4j-1.6.3.jar;../lib/cxf-rt-frontend-jaxrs-3.5.5.jar;../lib/xmlsec-2.2.3.jar;../lib/jakarta.xml.soap-api-1.4.1.jar;../lib/opensaml-xmlsec-api-3.4.6.jar;../lib/oro-2.0.8.jar;../lib/postgresql-42.6.0.jar;../lib/filecopy-2.0.3.jar;../lib/jboss-marshalling-river-2.0.12.Final.jar;../lib/trove-1.0.2.jar;../lib/jboss-marshalling-2.0.12.Final.jar;../lib/advancedPersistentLookupLib-1.5.jar;../lib/slf4j-api-1.7.34.jar;../lib/dom4j-2.1.3.jar;../lib/crypto-utils-7.1.16.jar;../lib/talendcsv-1.1.0.jar;nextcloud_apache_conf_create_file_0_1.jar;";
              					
              					if(audit_jar_path_tRunJob_3!=null && !audit_jar_path_tRunJob_3.isEmpty()) {
		      						classpath_tRunJob_3_5 += audit_jar_path_tRunJob_3;
		      					}
		      					
	        					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, dealChildJobLibrary_tRunJob_3.replaceJarPathsFromCrcMap(classpath_tRunJob_3_5), true);
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "test.nextcloud_apache_conf_create_file_0_1.nextcloud_apache_conf_create_file");
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "--father_pid="+pid);
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "--root_pid="+rootPid);
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "--father_node=tRunJob_3");
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "--context=Default");
		      				
		      					jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "%*");
		      				
			} else {
	      		
						paraList_tRunJob_3.add("java");
						String m2 = System.getProperty("talend.component.manager.m2.repository");
						if (m2 != null){
							paraList_tRunJob_3.add("-Dtalend.component.manager.m2.repository=" + m2);
						}
						
						if (Boolean.getBoolean("propagateLoggingConfiguration")) {
							String log4j1_config_tRunJob_3 = System.getProperty("log4j.configuration");
							if (log4j1_config_tRunJob_3 != null){
								paraList_tRunJob_3.add("-Dlog4j.configuration=" + log4j1_config_tRunJob_3);
							}
							String log4j2_config_tRunJob_3 = System.getProperty("log4j.configurationFile");
							if (log4j2_config_tRunJob_3 != null){
								paraList_tRunJob_3.add("-Dlog4j.configurationFile=" + log4j2_config_tRunJob_3);
							}
							if (log4j1_config_tRunJob_3 != null || log4j2_config_tRunJob_3 != null) {
								paraList_tRunJob_3.add("-DpropagateLoggingConfiguration=true");
							}
						}
						
						if(enableLogStash){
							System.getProperties().stringPropertyNames().stream()
								.filter(it -> it.startsWith("audit."))
								.forEach(key -> paraList_tRunJob_3.add("-D" + key + "=" + System.getProperty(key)));
						}
							
						System.getProperties().stringPropertyNames().stream()
							.filter(it -> it.startsWith("runtime.lineage.") || "classpath.extended".equals(it))
							.forEach(key -> paraList_tRunJob_3.add("-D" + key + "=" + System.getProperty(key)));
					
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "-Dtalend.component.manager.m2.repository=../lib");
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "-Xms256M");
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "-Xmx1024M");
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "-cp");
		      				
		      					String classpath_tRunJob_3_5 = ".:$ROOT_PATH:$ROOT_PATH/../lib/routines.jar:$ROOT_PATH/../lib/log4j-slf4j-impl-2.17.1.jar:$ROOT_PATH/../lib/log4j-api-2.17.1.jar:$ROOT_PATH/../lib/log4j-core-2.17.1.jar:$ROOT_PATH/../lib/log4j-1.2-api-2.17.1.jar:$ROOT_PATH/../lib/cxf-rt-features-logging-3.5.5.jar:$ROOT_PATH/../lib/stax2-api-4.2.1.jar:$ROOT_PATH/../lib/commons-codec-1.15.jar:$ROOT_PATH/../lib/cxf-core-3.5.5.jar:$ROOT_PATH/../lib/wss4j-policy-2.4.1.jar:$ROOT_PATH/../lib/opensaml-security-api-3.4.6.jar:$ROOT_PATH/../lib/opensaml-soap-api-3.4.6.jar:$ROOT_PATH/../lib/spring-context-5.3.29.jar:$ROOT_PATH/../lib/ehcache-3.9.3.jar:$ROOT_PATH/../lib/opensaml-profile-api-3.4.6.jar:$ROOT_PATH/../lib/org.apache.servicemix.specs.jaxws-api-2.2-2.9.0.jar:$ROOT_PATH/../lib/spring-expression-5.3.29.jar:$ROOT_PATH/../lib/javax.ws.rs-api-2.1.jar:$ROOT_PATH/../lib/jaxb-runtime-2.3.2.jar:$ROOT_PATH/../lib/cxf-rt-security-saml-3.5.5.jar:$ROOT_PATH/../lib/wss4j-ws-security-policy-stax-2.4.1.jar:$ROOT_PATH/../lib/cxf-rt-rs-client-3.5.5.jar:$ROOT_PATH/../lib/cxf-rt-rs-extension-providers-3.5.5.jar:$ROOT_PATH/../lib/opensaml-saml-api-3.4.6.jar:$ROOT_PATH/../lib/jakarta.jws-api-2.1.0.jar:$ROOT_PATH/../lib/opensaml-saml-impl-3.4.6.jar:$ROOT_PATH/../lib/spring-web-5.3.29.jar:$ROOT_PATH/../lib/opensaml-security-impl-3.4.6.jar:$ROOT_PATH/../lib/spring-core-5.3.29.jar:$ROOT_PATH/../lib/cxf-rt-transports-http-3.5.5.jar:$ROOT_PATH/../lib/jakarta.annotation-api-1.3.5.jar:$ROOT_PATH/../lib/opensaml-xacml-saml-impl-3.4.6.jar:$ROOT_PATH/../lib/commons-collections-3.2.2.jar:$ROOT_PATH/../lib/jasypt-1.9.3.jar:$ROOT_PATH/../lib/txw2-2.3.3.jar:$ROOT_PATH/../lib/joda-time-2.10.10.jar:$ROOT_PATH/../lib/bcprov-jdk18on-1.74.jar:$ROOT_PATH/../lib/commons-logging-1.2.jar:$ROOT_PATH/../lib/opensaml-core-3.4.6.jar:$ROOT_PATH/../lib/cxf-rt-ws-security-3.5.5.jar:$ROOT_PATH/../lib/wss4j-ws-security-stax-2.4.1.jar:$ROOT_PATH/../lib/wss4j-ws-security-dom-2.4.1.jar:$ROOT_PATH/../lib/javax.activation-1.2.0.jar:$ROOT_PATH/../lib/spring-aop-5.3.29.jar:$ROOT_PATH/../lib/opensaml-xacml-saml-api-3.4.6.jar:$ROOT_PATH/../lib/cxf-rt-wsdl-3.5.5.jar:$ROOT_PATH/../lib/security-common-8.8.8-SNAPSHOT.jar:$ROOT_PATH/../lib/wss4j-bindings-2.4.1.jar:$ROOT_PATH/../lib/neethi-3.1.1.jar:$ROOT_PATH/../lib/cxf-rt-bindings-soap-3.5.5.jar:$ROOT_PATH/../lib/istack-commons-runtime-3.0.10.jar:$ROOT_PATH/../lib/opensaml-xmlsec-impl-3.4.6.jar:$ROOT_PATH/../lib/jettison-1.5.4.jar:$ROOT_PATH/../lib/opensaml-xacml-api-3.4.6.jar:$ROOT_PATH/../lib/xmlschema-core-2.2.5.jar:$ROOT_PATH/../lib/jakarta.xml.bind-api-2.3.3.jar:$ROOT_PATH/../lib/woodstox-core-6.4.0.jar:$ROOT_PATH/../lib/aopalliance-1.0.jar:$ROOT_PATH/../lib/stax-ex-1.8.3.jar:$ROOT_PATH/../lib/opensaml-xacml-impl-3.4.6.jar:$ROOT_PATH/../lib/spring-webmvc-5.3.29.jar:$ROOT_PATH/../lib/guava-32.0.1-jre.jar:$ROOT_PATH/../lib/cxf-rt-security-3.5.5.jar:$ROOT_PATH/../lib/wss4j-ws-security-common-2.4.1.jar:$ROOT_PATH/../lib/jaxen-1.1.6.jar:$ROOT_PATH/../lib/cxf-rt-databinding-jaxb-3.5.5.jar:$ROOT_PATH/../lib/cryptacular-1.2.5.jar:$ROOT_PATH/../lib/cxf-rt-rs-security-oauth2-3.5.5.jar:$ROOT_PATH/../lib/spring-beans-5.3.29.jar:$ROOT_PATH/../lib/wsdl4j-1.6.3.jar:$ROOT_PATH/../lib/cxf-rt-frontend-jaxrs-3.5.5.jar:$ROOT_PATH/../lib/xmlsec-2.2.3.jar:$ROOT_PATH/../lib/jakarta.xml.soap-api-1.4.1.jar:$ROOT_PATH/../lib/opensaml-xmlsec-api-3.4.6.jar:$ROOT_PATH/../lib/oro-2.0.8.jar:$ROOT_PATH/../lib/postgresql-42.6.0.jar:$ROOT_PATH/../lib/filecopy-2.0.3.jar:$ROOT_PATH/../lib/jboss-marshalling-river-2.0.12.Final.jar:$ROOT_PATH/../lib/trove-1.0.2.jar:$ROOT_PATH/../lib/jboss-marshalling-2.0.12.Final.jar:$ROOT_PATH/../lib/advancedPersistentLookupLib-1.5.jar:$ROOT_PATH/../lib/slf4j-api-1.7.34.jar:$ROOT_PATH/../lib/dom4j-2.1.3.jar:$ROOT_PATH/../lib/crypto-utils-7.1.16.jar:$ROOT_PATH/../lib/talendcsv-1.1.0.jar:$ROOT_PATH/nextcloud_apache_conf_create_file_0_1.jar:";
		      					
		      					if(audit_jar_path_tRunJob_3!=null && !audit_jar_path_tRunJob_3.isEmpty()) {
		      						classpath_tRunJob_3_5 += audit_jar_path_tRunJob_3;
		      					}
		      					
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, dealChildJobLibrary_tRunJob_3.replaceJarPathsFromCrcMap(classpath_tRunJob_3_5).replace("$ROOT_PATH",System.getProperty("user.dir")), true);
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "test.nextcloud_apache_conf_create_file_0_1.nextcloud_apache_conf_create_file");
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "--father_pid="+pid);
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "--root_pid="+rootPid);
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "--father_node=tRunJob_3");
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "--context=Default");
		      				
								jvm_argument_helper_tRunJob_3.addArgumentsTo(paraList_tRunJob_3, "$@");
		      				
			}

			
			
	  	
		if(enableLogStash){
			paraList_tRunJob_3.add("--audit.enabled="+enableLogStash);
		}
		
	//for feature:10589
	
		paraList_tRunJob_3.add("--stat_port=" + null);
	

	if(resuming_logs_dir_path != null){
		paraList_tRunJob_3.add("--resuming_logs_dir_path=" + resuming_logs_dir_path);
	}
	String childResumePath_tRunJob_3 = ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path);
	String tRunJobName_tRunJob_3 = ResumeUtil.getRighttRunJob(resuming_checkpoint_path);
	if("tRunJob_3".equals(tRunJobName_tRunJob_3) && childResumePath_tRunJob_3 != null){
		paraList_tRunJob_3.add("--resuming_checkpoint_path=" + ResumeUtil.getChildJobCheckPointPath(resuming_checkpoint_path));
	}
	paraList_tRunJob_3.add("--parent_part_launcher=JOB:" + jobName + "/NODE:tRunJob_3");
	
	java.util.Map<String, Object> parentContextMap_tRunJob_3 = new java.util.HashMap<String, Object>();

	
		
		context.synchronizeContext();
            class ContextProcessor_tRunJob_3 {
                    private void transmitContext_0() {
                    parentContextMap_tRunJob_3.put("ncApacheConfDir", context.ncApacheConfDir);
                    paraList_tRunJob_3.add("--context_type " + "ncApacheConfDir" + "=" + "id_Directory");
                    parentContextMap_tRunJob_3.put("ncHost", context.ncHost);
                    paraList_tRunJob_3.add("--context_type " + "ncHost" + "=" + "id_String");
                    parentContextMap_tRunJob_3.put("ncPassword", context.ncPassword);
                    paraList_tRunJob_3.add("--context_type " + "ncPassword" + "=" + "id_Password");
                    parentContextMap_tRunJob_3.put("ncRevProxy", context.ncRevProxy);
                    paraList_tRunJob_3.add("--context_type " + "ncRevProxy" + "=" + "id_String");
                    parentContextMap_tRunJob_3.put("ncUsername", context.ncUsername);
                    paraList_tRunJob_3.add("--context_type " + "ncUsername" + "=" + "id_String");
                    parentContextMap_tRunJob_3.put("pgDatabase", context.pgDatabase);
                    paraList_tRunJob_3.add("--context_type " + "pgDatabase" + "=" + "id_String");
                    parentContextMap_tRunJob_3.put("pgHost", context.pgHost);
                    paraList_tRunJob_3.add("--context_type " + "pgHost" + "=" + "id_String");
                    parentContextMap_tRunJob_3.put("pgPassword", context.pgPassword);
                    paraList_tRunJob_3.add("--context_type " + "pgPassword" + "=" + "id_Password");
                    parentContextMap_tRunJob_3.put("pgPort", context.pgPort);
                    paraList_tRunJob_3.add("--context_type " + "pgPort" + "=" + "id_String");
                    parentContextMap_tRunJob_3.put("pgSchema", context.pgSchema);
                    paraList_tRunJob_3.add("--context_type " + "pgSchema" + "=" + "id_String");
                    parentContextMap_tRunJob_3.put("pgUsername", context.pgUsername);
                    paraList_tRunJob_3.add("--context_type " + "pgUsername" + "=" + "id_String");
                    parentContextMap_tRunJob_3.put("ncRemoveAllShares", context.ncRemoveAllShares);
                    paraList_tRunJob_3.add("--context_type " + "ncRemoveAllShares" + "=" + "id_Integer");
                        }
                    public void transmitAllContext() {
                        transmitContext_0();
                    }
            }
            new ContextProcessor_tRunJob_3().transmitAllContext();
		java.util.Enumeration<?> propertyNames_tRunJob_3 = context.propertyNames();
		while (propertyNames_tRunJob_3.hasMoreElements()) {
			String key_tRunJob_3 = (String) propertyNames_tRunJob_3.nextElement();
			Object value_tRunJob_3 = (Object) context.get(key_tRunJob_3);
			if(value_tRunJob_3!=null) {  
				
					paraList_tRunJob_3.add("--context_param " + key_tRunJob_3 + "=" + value_tRunJob_3);
					
			} else {
				paraList_tRunJob_3.add("--context_param " + key_tRunJob_3 + "=" + NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY);
			}
			
		}
		

	Object obj_tRunJob_3 = null;

	
	
				class ConsoleHelper_tRunJob_3 {
					private Thread getNormalThread(Process process) {
						return new Thread() {
							public void run() {
								try {
									java.io.BufferedReader reader = new java.io.BufferedReader(
											new java.io.InputStreamReader(
													process.getInputStream()));
									String line = "";
									try {
										while ((line = reader.readLine()) != null) {
											System.out.println(line);
										}
									} finally {
										reader.close();
									}
								} catch (java.io.IOException ioe) {
globalMap.put("tRunJob_3_ERROR_MESSAGE",ioe.getMessage());
						            
									ioe.printStackTrace();
								}
							}
						};
					}

					private Thread getErrorThread(Process process, StringBuffer sb) {
						return new Thread() {
							public void run() {
								try {
									java.io.BufferedReader reader = new java.io.BufferedReader(
											new java.io.InputStreamReader(
													process.getErrorStream()));
									String line = "";
									try {
										while ((line = reader.readLine()) != null) {
											sb.append(line)
													.append("\n");
										}
									} finally {
										reader.close();
									}
								} catch (java.io.IOException ioe) {
globalMap.put("tRunJob_3_ERROR_MESSAGE",ioe.getMessage());
						            
									ioe.printStackTrace();
								}
							}
						};
					}
				}
				ConsoleHelper_tRunJob_3 consoleHelper_tRunJob_3 = new ConsoleHelper_tRunJob_3();

		Runtime runtime_tRunJob_3 = Runtime.getRuntime();
		Process ps_tRunJob_3 = null;
		
		//0 indicates normal termination
        int result_tRunJob_3;
        StringBuffer errorMsg_tRunJob_3 = new StringBuffer();
        try {
            ps_tRunJob_3 = runtime_tRunJob_3.exec((String[])paraList_tRunJob_3.toArray(new String[paraList_tRunJob_3.size()]));

            Thread normal_tRunJob_3 = consoleHelper_tRunJob_3.getNormalThread(ps_tRunJob_3);
            normal_tRunJob_3.start();

            Thread error_tRunJob_3 = consoleHelper_tRunJob_3.getErrorThread(ps_tRunJob_3, errorMsg_tRunJob_3);
            error_tRunJob_3.start();

            result_tRunJob_3 = ps_tRunJob_3.waitFor();
            normal_tRunJob_3.join();
            error_tRunJob_3.join();
        } catch (ThreadDeath tde) {
globalMap.put("tRunJob_3_ERROR_MESSAGE",tde.getMessage());
            ps_tRunJob_3.destroy();
            throw tde;
        }

		globalMap.put("tRunJob_3_CHILD_RETURN_CODE",result_tRunJob_3);
		if(result_tRunJob_3 != 0){
   			globalMap.put("tRunJob_3_CHILD_EXCEPTION_STACKTRACE",errorMsg_tRunJob_3.toString());
			
				
				System.err.println("Child job returns " + result_tRunJob_3 + ". It doesn't terminate normally.\n" + errorMsg_tRunJob_3.toString());
			
  		}

		

 


	tos_count_tRunJob_3++;

/**
 * [tRunJob_3 main ] stop
 */
	
	/**
	 * [tRunJob_3 process_data_begin ] start
	 */

	

	
	
	currentComponent="tRunJob_3";
	
	

 



/**
 * [tRunJob_3 process_data_begin ] stop
 */
	
	/**
	 * [tRunJob_3 process_data_end ] start
	 */

	

	
	
	currentComponent="tRunJob_3";
	
	

 



/**
 * [tRunJob_3 process_data_end ] stop
 */
	
	/**
	 * [tRunJob_3 end ] start
	 */

	

	
	
	currentComponent="tRunJob_3";
	
	

 

ok_Hash.put("tRunJob_3", true);
end_Hash.put("tRunJob_3", System.currentTimeMillis());




/**
 * [tRunJob_3 end ] stop
 */
				}//end the resume

				



	
			}catch(java.lang.Exception e){	
				
				TalendException te = new TalendException(e, currentComponent, cLabel, globalMap);
				
				throw te;
			}catch(java.lang.Error error){	
				
					runStat.stopThreadStat();
				
				throw error;
			}finally{
				
				try{
					
	
	/**
	 * [tRunJob_3 finally ] start
	 */

	

	
	
	currentComponent="tRunJob_3";
	
	
	
 



/**
 * [tRunJob_3 finally ] stop
 */
				}catch(java.lang.Exception e){	
					//ignore
				}catch(java.lang.Error error){
					//ignore
				}
				resourceMap = null;
			}
		

		globalMap.put("tRunJob_3_SUBPROCESS_STATE", 1);
	}
	
    public String resuming_logs_dir_path = null;
    public String resuming_checkpoint_path = null;
    public String parent_part_launcher = null;
    private String resumeEntryMethodName = null;
    private boolean globalResumeTicket = false;

    public boolean watch = false;
    // portStats is null, it means don't execute the statistics
    public Integer portStats = null;
    public int portTraces = 4334;
    public String clientHost;
    public String defaultClientHost = "localhost";
    public String contextStr = "Default";
    public boolean isDefaultContext = true;
    public String pid = "0";
    public String rootPid = null;
    public String fatherPid = null;
    public String fatherNode = null;
    public long startTime = 0;
    public boolean isChildJob = false;
    public String log4jLevel = "";
    
    private boolean enableLogStash;

    private boolean execStat = true;

    private ThreadLocal<java.util.Map<String, String>> threadLocal = new ThreadLocal<java.util.Map<String, String>>() {
        protected java.util.Map<String, String> initialValue() {
            java.util.Map<String,String> threadRunResultMap = new java.util.HashMap<String, String>();
            threadRunResultMap.put("errorCode", null);
            threadRunResultMap.put("status", "");
            return threadRunResultMap;
        };
    };


    protected PropertiesWithType context_param = new PropertiesWithType();
    public java.util.Map<String, Object> parentContextMap = new java.util.HashMap<String, Object>();

    public String status= "";
    
    
    private final static java.util.Properties jobInfo = new java.util.Properties();
    private final static java.util.Map<String,String> mdcInfo = new java.util.HashMap<>();
    private final static java.util.concurrent.atomic.AtomicLong subJobPidCounter = new java.util.concurrent.atomic.AtomicLong();


    public static void main(String[] args){
        final nextcloud_apache_conf_main nextcloud_apache_conf_mainClass = new nextcloud_apache_conf_main();

        int exitCode = nextcloud_apache_conf_mainClass.runJobInTOS(args);

        System.exit(exitCode);
    }
	

	
	
	private void getjobInfo() {
		final String TEMPLATE_PATH = "src/main/templates/jobInfo_template.properties";
		final String BUILD_PATH = "../jobInfo.properties";
		final String path = this.getClass().getResource("").getPath();
		if(path.lastIndexOf("target") > 0) {
			final java.io.File templateFile = new java.io.File(
					path.substring(0, path.lastIndexOf("target")).concat(TEMPLATE_PATH));
			if (templateFile.exists()) {
				readJobInfo(templateFile);
				return;
			}
		}
			readJobInfo(new java.io.File(BUILD_PATH));
	}

    private void readJobInfo(java.io.File jobInfoFile){
	
        if(jobInfoFile.exists()) {
            try (java.io.InputStream is = new java.io.FileInputStream(jobInfoFile)) {
            	jobInfo.load(is);
            } catch (IOException e) {
            	 
                
            }
        }
    }


    public String[][] runJob(String[] args) {

        int exitCode = runJobInTOS(args);
        String[][] bufferValue = new String[][] { { Integer.toString(exitCode) } };

        return bufferValue;
    }

    public boolean hastBufferOutputComponent() {
		boolean hastBufferOutput = false;
    	
        return hastBufferOutput;
    }

    public int runJobInTOS(String[] args) {
	   	// reset status
	   	status = "";
	   	
        String lastStr = "";
        for (String arg : args) {
            if (arg.equalsIgnoreCase("--context_param")) {
                lastStr = arg;
            } else if (lastStr.equals("")) {
                evalParam(arg);
            } else {
                evalParam(lastStr + " " + arg);
                lastStr = "";
            }
        }
        enableLogStash = "true".equalsIgnoreCase(System.getProperty("audit.enabled"));


		
		

        if(clientHost == null) {
            clientHost = defaultClientHost;
        }

        if(pid == null || "0".equals(pid)) {
            pid = TalendString.getAsciiRandomString(6);
        }


        if (rootPid==null) {
            rootPid = pid;
        }


        if (fatherPid==null) {
            fatherPid = pid;
        }else{
            isChildJob = true;
        }

        if (portStats != null) {
            // portStats = -1; //for testing
            if (portStats < 0 || portStats > 65535) {
                // issue:10869, the portStats is invalid, so this client socket can't open
                System.err.println("The statistics socket port " + portStats + " is invalid.");
                execStat = false;
            }
        } else {
            execStat = false;
        }
        boolean inOSGi = routines.system.BundleUtils.inOSGi();

        try {
            java.util.Dictionary<String, Object> jobProperties = null;
            if (inOSGi) {
                jobProperties = routines.system.BundleUtils.getJobProperties(jobName);
    
                if (jobProperties != null && jobProperties.get("context") != null) {
                    contextStr = (String)jobProperties.get("context");
                }
            }
            //call job/subjob with an existing context, like: --context=production. if without this parameter, there will use the default context instead.
            java.io.InputStream inContext = nextcloud_apache_conf_main.class.getClassLoader().getResourceAsStream("test/nextcloud_apache_conf_main_0_1/contexts/" + contextStr + ".properties");
            if (inContext == null) {
                inContext = nextcloud_apache_conf_main.class.getClassLoader().getResourceAsStream("config/contexts/" + contextStr + ".properties");
            }
            if (inContext != null) {
                try {
                    //defaultProps is in order to keep the original context value
                    if(context != null && context.isEmpty()) {
    	                defaultProps.load(inContext);
    	                if (inOSGi && jobProperties != null) {
                             java.util.Enumeration<String> keys = jobProperties.keys();
                             while (keys.hasMoreElements()) {
                                 String propKey = keys.nextElement();
                                 if (defaultProps.containsKey(propKey)) {
                                     defaultProps.put(propKey, (String) jobProperties.get(propKey));
                                 }
                             }
    	                }
    	                context = new ContextProperties(defaultProps);
                    }
                } finally {
                    inContext.close();
                }
            } else if (!isDefaultContext) {
                //print info and job continue to run, for case: context_param is not empty.
                System.err.println("Could not find the context " + contextStr);
            }
            
            if(!context_param.isEmpty()) {
                context.putAll(context_param);
				//set types for params from parentJobs
				for (Object key: context_param.keySet()){
					String context_key = key.toString();
					String context_type = context_param.getContextType(context_key);
					context.setContextType(context_key, context_type);

				}
            }
            class ContextProcessing {
                private void processContext_0() {
                        context.setContextType("ncApacheConfDir", "id_Directory");
                        if(context.getStringValue("ncApacheConfDir") == null) {
                            context.ncApacheConfDir = null;
                        } else {
                            context.ncApacheConfDir=(String) context.getProperty("ncApacheConfDir");
                        }
                        context.setContextType("ncHost", "id_String");
                        if(context.getStringValue("ncHost") == null) {
                            context.ncHost = null;
                        } else {
                            context.ncHost=(String) context.getProperty("ncHost");
                        }
                        context.setContextType("ncPassword", "id_Password");
                        if(context.getStringValue("ncPassword") == null) {
                            context.ncPassword = null;
                        } else {
                            String pwd_ncPassword_value = context.getProperty("ncPassword");
                            context.ncPassword = null;
                            if(pwd_ncPassword_value!=null) {
                                if(context_param.containsKey("ncPassword")) {//no need to decrypt if it come from program argument or parent job runtime
                                    context.ncPassword = pwd_ncPassword_value;
                                } else if (!pwd_ncPassword_value.isEmpty()) {
                                    try {
                                        context.ncPassword = routines.system.PasswordEncryptUtil.decryptPassword(pwd_ncPassword_value);
                                        context.put("ncPassword",context.ncPassword);
                                    } catch (java.lang.RuntimeException e) {
                                        //do nothing
                                    }
                                }
                            }
                        }
                        context.setContextType("ncRevProxy", "id_String");
                        if(context.getStringValue("ncRevProxy") == null) {
                            context.ncRevProxy = null;
                        } else {
                            context.ncRevProxy=(String) context.getProperty("ncRevProxy");
                        }
                        context.setContextType("ncUsername", "id_String");
                        if(context.getStringValue("ncUsername") == null) {
                            context.ncUsername = null;
                        } else {
                            context.ncUsername=(String) context.getProperty("ncUsername");
                        }
                        context.setContextType("pgDatabase", "id_String");
                        if(context.getStringValue("pgDatabase") == null) {
                            context.pgDatabase = null;
                        } else {
                            context.pgDatabase=(String) context.getProperty("pgDatabase");
                        }
                        context.setContextType("pgHost", "id_String");
                        if(context.getStringValue("pgHost") == null) {
                            context.pgHost = null;
                        } else {
                            context.pgHost=(String) context.getProperty("pgHost");
                        }
                        context.setContextType("pgPassword", "id_Password");
                        if(context.getStringValue("pgPassword") == null) {
                            context.pgPassword = null;
                        } else {
                            String pwd_pgPassword_value = context.getProperty("pgPassword");
                            context.pgPassword = null;
                            if(pwd_pgPassword_value!=null) {
                                if(context_param.containsKey("pgPassword")) {//no need to decrypt if it come from program argument or parent job runtime
                                    context.pgPassword = pwd_pgPassword_value;
                                } else if (!pwd_pgPassword_value.isEmpty()) {
                                    try {
                                        context.pgPassword = routines.system.PasswordEncryptUtil.decryptPassword(pwd_pgPassword_value);
                                        context.put("pgPassword",context.pgPassword);
                                    } catch (java.lang.RuntimeException e) {
                                        //do nothing
                                    }
                                }
                            }
                        }
                        context.setContextType("pgPort", "id_String");
                        if(context.getStringValue("pgPort") == null) {
                            context.pgPort = null;
                        } else {
                            context.pgPort=(String) context.getProperty("pgPort");
                        }
                        context.setContextType("pgSchema", "id_String");
                        if(context.getStringValue("pgSchema") == null) {
                            context.pgSchema = null;
                        } else {
                            context.pgSchema=(String) context.getProperty("pgSchema");
                        }
                        context.setContextType("pgUsername", "id_String");
                        if(context.getStringValue("pgUsername") == null) {
                            context.pgUsername = null;
                        } else {
                            context.pgUsername=(String) context.getProperty("pgUsername");
                        }
                        context.setContextType("ncRemoveAllShares", "id_Integer");
                        if(context.getStringValue("ncRemoveAllShares") == null) {
                            context.ncRemoveAllShares = null;
                        } else {
                            try{
                                context.ncRemoveAllShares=routines.system.ParserUtils.parseTo_Integer (context.getProperty("ncRemoveAllShares"));
                            } catch(NumberFormatException e){
                                System.err.println(String.format("Null value will be used for context parameter %s: %s", "ncRemoveAllShares", e.getMessage()));
                                context.ncRemoveAllShares=null;
                            }
                        }
                } 
                public void processAllContext() {
                        processContext_0();
                }
            }

            new ContextProcessing().processAllContext();
        } catch (java.io.IOException ie) {
            System.err.println("Could not load context "+contextStr);
            ie.printStackTrace();
        }

        // get context value from parent directly
        if (parentContextMap != null && !parentContextMap.isEmpty()) {if (parentContextMap.containsKey("ncApacheConfDir")) {
                context.ncApacheConfDir = (String) parentContextMap.get("ncApacheConfDir");
            }if (parentContextMap.containsKey("ncHost")) {
                context.ncHost = (String) parentContextMap.get("ncHost");
            }if (parentContextMap.containsKey("ncPassword")) {
                context.ncPassword = (java.lang.String) parentContextMap.get("ncPassword");
            }if (parentContextMap.containsKey("ncRevProxy")) {
                context.ncRevProxy = (String) parentContextMap.get("ncRevProxy");
            }if (parentContextMap.containsKey("ncUsername")) {
                context.ncUsername = (String) parentContextMap.get("ncUsername");
            }if (parentContextMap.containsKey("pgDatabase")) {
                context.pgDatabase = (String) parentContextMap.get("pgDatabase");
            }if (parentContextMap.containsKey("pgHost")) {
                context.pgHost = (String) parentContextMap.get("pgHost");
            }if (parentContextMap.containsKey("pgPassword")) {
                context.pgPassword = (java.lang.String) parentContextMap.get("pgPassword");
            }if (parentContextMap.containsKey("pgPort")) {
                context.pgPort = (String) parentContextMap.get("pgPort");
            }if (parentContextMap.containsKey("pgSchema")) {
                context.pgSchema = (String) parentContextMap.get("pgSchema");
            }if (parentContextMap.containsKey("pgUsername")) {
                context.pgUsername = (String) parentContextMap.get("pgUsername");
            }if (parentContextMap.containsKey("ncRemoveAllShares")) {
                context.ncRemoveAllShares = (Integer) parentContextMap.get("ncRemoveAllShares");
            }
        }

        //Resume: init the resumeUtil
        resumeEntryMethodName = ResumeUtil.getResumeEntryMethodName(resuming_checkpoint_path);
        resumeUtil = new ResumeUtil(resuming_logs_dir_path, isChildJob, rootPid);
        resumeUtil.initCommonInfo(pid, rootPid, fatherPid, projectName, jobName, contextStr, jobVersion);

		List<String> parametersToEncrypt = new java.util.ArrayList<String>();
			parametersToEncrypt.add("ncPassword");
			parametersToEncrypt.add("pgPassword");
        //Resume: jobStart
        resumeUtil.addLog("JOB_STARTED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "","","","",resumeUtil.convertToJsonText(context,ContextProperties.class,parametersToEncrypt));


if(execStat) {
    try {
        runStat.openSocket(!isChildJob);
        runStat.setAllPID(rootPid, fatherPid, pid, jobName);
        runStat.startThreadStat(clientHost, portStats);
        runStat.updateStatOnJob(RunStat.JOBSTART, fatherNode);
    } catch (java.io.IOException ioException) {
        ioException.printStackTrace();
    }
}



	
	    java.util.concurrent.ConcurrentHashMap<Object, Object> concurrentHashMap = new java.util.concurrent.ConcurrentHashMap<Object, Object>();
	    globalMap.put("concurrentHashMap", concurrentHashMap);
	

    long startUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
    long endUsedMemory = 0;
    long end = 0;

    startTime = System.currentTimeMillis();


this.globalResumeTicket = true;//to run tPreJob





this.globalResumeTicket = false;//to run others jobs

try {
errorCode = null;tRunJob_2Process(globalMap);
if(!"failure".equals(status)) { status = "end"; }
}catch (TalendException e_tRunJob_2) {
globalMap.put("tRunJob_2_SUBPROCESS_STATE", -1);

e_tRunJob_2.printStackTrace();

}

this.globalResumeTicket = true;//to run tPostJob




        end = System.currentTimeMillis();

        if (watch) {
            System.out.println((end-startTime)+" milliseconds");
        }

        endUsedMemory = Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory();
        if (false) {
            System.out.println((endUsedMemory - startUsedMemory) + " bytes memory increase when running : nextcloud_apache_conf_main");
        }



if (execStat) {
    runStat.updateStatOnJob(RunStat.JOBEND, fatherNode);
    runStat.stopThreadStat();
}
    int returnCode = 0;


    if(errorCode == null) {
         returnCode = status != null && status.equals("failure") ? 1 : 0;
    } else {
         returnCode = errorCode.intValue();
    }
    resumeUtil.addLog("JOB_ENDED", "JOB:" + jobName, parent_part_launcher, Thread.currentThread().getId() + "", "","" + returnCode,"","","");
    resumeUtil.flush();


    return returnCode;

  }

    // only for OSGi env
    public void destroy() {


    }














    private java.util.Map<String, Object> getSharedConnections4REST() {
        java.util.Map<String, Object> connections = new java.util.HashMap<String, Object>();






        return connections;
    }

    private void evalParam(String arg) {
        if (arg.startsWith("--resuming_logs_dir_path")) {
            resuming_logs_dir_path = arg.substring(25);
        } else if (arg.startsWith("--resuming_checkpoint_path")) {
            resuming_checkpoint_path = arg.substring(27);
        } else if (arg.startsWith("--parent_part_launcher")) {
            parent_part_launcher = arg.substring(23);
        } else if (arg.startsWith("--watch")) {
            watch = true;
        } else if (arg.startsWith("--stat_port=")) {
            String portStatsStr = arg.substring(12);
            if (portStatsStr != null && !portStatsStr.equals("null")) {
                portStats = Integer.parseInt(portStatsStr);
            }
        } else if (arg.startsWith("--trace_port=")) {
            portTraces = Integer.parseInt(arg.substring(13));
        } else if (arg.startsWith("--client_host=")) {
            clientHost = arg.substring(14);
        } else if (arg.startsWith("--context=")) {
            contextStr = arg.substring(10);
            isDefaultContext = false;
        } else if (arg.startsWith("--father_pid=")) {
            fatherPid = arg.substring(13);
        } else if (arg.startsWith("--root_pid=")) {
            rootPid = arg.substring(11);
        } else if (arg.startsWith("--father_node=")) {
            fatherNode = arg.substring(14);
        } else if (arg.startsWith("--pid=")) {
            pid = arg.substring(6);
        } else if (arg.startsWith("--context_type")) {
            String keyValue = arg.substring(15);
			int index = -1;
            if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
                if (fatherPid==null) {
                    context_param.setContextType(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
                } else { // the subjob won't escape the especial chars
                    context_param.setContextType(keyValue.substring(0, index), keyValue.substring(index + 1) );
                }

            }

		} else if (arg.startsWith("--context_param")) {
            String keyValue = arg.substring(16);
            int index = -1;
            if (keyValue != null && (index = keyValue.indexOf('=')) > -1) {
                if (fatherPid==null) {
                    context_param.put(keyValue.substring(0, index), replaceEscapeChars(keyValue.substring(index + 1)));
                } else { // the subjob won't escape the especial chars
                    context_param.put(keyValue.substring(0, index), keyValue.substring(index + 1) );
                }
            }
        } else if (arg.startsWith("--context_file")) {
        	String keyValue = arg.substring(15);
        	String filePath = new String(java.util.Base64.getDecoder().decode(keyValue));
        	java.nio.file.Path contextFile = java.nio.file.Paths.get(filePath);
            try (java.io.BufferedReader reader = java.nio.file.Files.newBufferedReader(contextFile)) {
                String line;
                while ((line = reader.readLine()) != null) {
                    int index = -1;
                    if ( (index = line.indexOf('=')) > -1) {
							if (line.startsWith("--context_param")) {
								if ("id_Password".equals(context_param.getContextType(line.substring(16, index)))) {
									context_param.put(line.substring(16, index), routines.system.PasswordEncryptUtil.decryptPassword(
											line.substring(index + 1)));
								} else {
									context_param.put(line.substring(16, index), line.substring(index + 1));
								}
							}else {//--context_type
								context_param.setContextType(line.substring(15, index), line.substring(index + 1));
							}
                    }
                }
            } catch (java.io.IOException e) {
            	System.err.println("Could not load the context file: " + filePath);
                e.printStackTrace();
            }
        } else if (arg.startsWith("--log4jLevel=")) {
            log4jLevel = arg.substring(13);
		} else if (arg.startsWith("--audit.enabled") && arg.contains("=")) {//for trunjob call
		    final int equal = arg.indexOf('=');
			final String key = arg.substring("--".length(), equal);
			System.setProperty(key, arg.substring(equal + 1));
		}
    }
    
    private static final String NULL_VALUE_EXPRESSION_IN_COMMAND_STRING_FOR_CHILD_JOB_ONLY = "<TALEND_NULL>";

    private final String[][] escapeChars = {
        {"\\\\","\\"},{"\\n","\n"},{"\\'","\'"},{"\\r","\r"},
        {"\\f","\f"},{"\\b","\b"},{"\\t","\t"}
        };
    private String replaceEscapeChars (String keyValue) {

		if (keyValue == null || ("").equals(keyValue.trim())) {
			return keyValue;
		}

		StringBuilder result = new StringBuilder();
		int currIndex = 0;
		while (currIndex < keyValue.length()) {
			int index = -1;
			// judege if the left string includes escape chars
			for (String[] strArray : escapeChars) {
				index = keyValue.indexOf(strArray[0],currIndex);
				if (index>=0) {

					result.append(keyValue.substring(currIndex, index + strArray[0].length()).replace(strArray[0], strArray[1]));
					currIndex = index + strArray[0].length();
					break;
				}
			}
			// if the left string doesn't include escape chars, append the left into the result
			if (index < 0) {
				result.append(keyValue.substring(currIndex));
				currIndex = currIndex + keyValue.length();
			}
		}

		return result.toString();
    }

    public Integer getErrorCode() {
        return errorCode;
    }


    public String getStatus() {
        return status;
    }

    ResumeUtil resumeUtil = null;
}
/************************************************************************************************
 *     92141 characters generated by Talaxie Open Studio for Data Integration 
 *     on the December 2, 2024, 9:37:44 AM CET
 ************************************************************************************************/